Bug 1330705 - open() and openat() ignore 'mode' with O_TMPFILE on newer kernels
Summary: open() and openat() ignore 'mode' with O_TMPFILE on newer kernels
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: glibc
Version: 7.2
Hardware: All
OS: Linux
medium
medium
Target Milestone: rc
: 7.4
Assignee: Florian Weimer
QA Contact: Sergey Kolosov
URL:
Whiteboard:
: 1375984 1386506 1451173 (view as bug list)
Depends On:
Blocks: 1299988 1413146 1330740 1358760 1381083
TreeView+ depends on / blocked
 
Reported: 2016-04-26 18:08 UTC by Jeff Bastian
Modified: 2017-08-01 18:06 UTC (History)
16 users (show)

Fixed In Version: glibc-2.17-160.el7
Doc Type: No Doc Update
Doc Text:
undefined
Clone Of:
: 1375984 (view as bug list)
Environment:
Last Closed: 2017-08-01 18:06:55 UTC
Target Upstream Version:


Attachments (Terms of Use)
reproducer and test program (1.16 KB, text/plain)
2016-04-26 18:08 UTC, Jeff Bastian
no flags Details


Links
System ID Private Priority Status Summary Last Updated
IBM Linux Technology Center 156724 0 None None None 2019-01-28 14:59:21 UTC
Red Hat Product Errata RHSA-2017:1916 0 normal SHIPPED_LIVE Moderate: glibc security, bug fix, and enhancement update 2017-08-01 18:05:43 UTC
Sourceware 17523 0 P2 RESOLVED open() and openat() ignore 'mode' with O_TMPFILE 2021-02-03 19:38:27 UTC
Sourceware 17912 0 P2 RESOLVED powerpc/arm/arm64/m68k: Wrong value of O_TMPFILE 2021-02-03 19:38:27 UTC

Description Jeff Bastian 2016-04-26 18:08:49 UTC
Created attachment 1151054 [details]
reproducer and test program

Description of problem:
The RHEL Server for ARM kernel is based on upstream kernel-4.5.0, and this kernel adds a new O_TMPFILE flag to the open() and openat() syscalls.  glibc needs an update to support setting the file permissions when using O_TMPFILE without O_CREAT.  See upstream bug
  https://sourceware.org/bugzilla/show_bug.cgi?id=17523

Attached are two patches that (1) define O_TMPFILE and (2) update the open() and openat() syscall wrappers to support the mode.

Version-Release number of selected component (if applicable):
glibc-2.17-105.el7

How reproducible:
always

Steps to Reproduce:
1. on a 64-bit ARM system, compile and run the attached o_tmpfile.c test program

Actual results:
~]# ./a.out
/proc/self/fd/3 -> /root/#201425340 (deleted) file created with O_TMPFILE
/proc/self/fd/3 has mode 00
FAIL: mode is not 0600

Expected results:
~]# ./a.out
/proc/self/fd/3 -> /root/#201867825 (deleted) file created with O_TMPFILE
/proc/self/fd/3 has mode 0600

Additional info:
The problem was originally discovered by LTP's openat03 and open14 tests.  This is another method to reproduce and test the bug.

Comment 5 Florian Weimer 2016-09-14 12:20:30 UTC
*** Bug 1375984 has been marked as a duplicate of this bug. ***

Comment 10 Florian Weimer 2016-09-20 19:08:13 UTC
I posted a test case upstream:

  https://sourceware.org/ml/libc-alpha/2016-09/msg00341.html

Comment 17 Chunyu Hu 2016-10-19 11:41:42 UTC
*** Bug 1386506 has been marked as a duplicate of this bug. ***

Comment 21 Florian Weimer 2017-05-20 07:25:07 UTC
*** Bug 1451173 has been marked as a duplicate of this bug. ***

Comment 22 errata-xmlrpc 2017-08-01 18:06:55 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2017:1916


Note You need to log in before you can comment on or make changes to this bug.